Program EprProg ;  {Program za vpis epromov}
uses dos,crt;
var
  f:file;
  d,x,x3:byte;
  counter,err,i,ii,proc:word;
  adr:word;
  blok:array[0..32767] of byte;
  flen:longint;
  tip32k:boolean;
  OldTimer  : Procedure; { save BIOS intr 8 }

Procedure CLI;             inline($FA);
Procedure STI;             inline($FB);
Procedure PUSHF;           inline($9C);
Procedure STROBE259;       begin Port [adr+2]:=3; Port [adr+2]:=1; end;
Procedure STROBE573;       begin Port [adr+2]:=0; Port [adr+2]:=1; end;
Procedure PGM(sw:byte);    begin Port [adr]:=4+sw; strobe259; end;
Procedure VPG(sw:byte);    begin Port [adr]:=6+(sw xor 1); strobe259; end;
Procedure OE(sw:byte);     begin Port [adr]:=8+sw; strobe259; end;
Procedure CE(sw:byte);     begin Port [adr]:=10+sw; strobe259; end;
Procedure CKA(sw:byte);    begin Port [adr]:=12+sw; strobe259; end;
Procedure CKR(sw:byte);    begin Port [adr]:=14+sw; strobe259; end;
Procedure CLK;             begin Port [adr]:=12; strobe259;
                                 Port [adr]:=13; strobe259; end;
Procedure Load165;         begin Port [adr]:=$00; Port [adr]:=$10; end;
Procedure Shift165;        begin Port [adr]:=$10; Strobe573;Port [adr]:=$50;
                                 Strobe573; Port [adr]:=$10; Strobe573; end;

Procedure SETadr32(sw:integer);
                           begin Port [adr]:=(sw and 1) or $0;strobe259;
                                 sw:= sw shr(1);
                                 Port [adr]:=(sw and 1) or $2;strobe259;
                                 sw:= sw shr(1);
                                 Port [adr]:=(sw and 1) or $4;strobe259; end;

Procedure SETadr16(sw:integer);
                           begin Port [adr]:=(sw and 1)or $0;strobe259;
                                 sw:= sw shr(1);
                                 Port [adr]:=(sw and 1)or $2;strobe259; end;

Procedure DefPort;
begin
  adr:=MemW[0:$408];d:=0;Port[adr]:=$aa; Strobe573; Load165;
  for ii:=0 to 7 do begin
      d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165; end;
  if d=$55 then begin write('na LPT1'); end
  else begin adr:=MemW[0:$40A];d:=0; Port[adr]:=$aa; Strobe573; Load165;
       for ii:=0 to 7 do begin
           d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165; end;
       if d<>$55 then begin WriteLn('Napaka programatorja!'^G); halt(0); end;
       Write('na LPT2') end;
end;
{$F+}
procedure ProgByte32; interrupt;
begin
   if (x<25) and (x>0) then begin
      OE(0);
      for d:=0 to 255 do;
      if Port[adr+1] and $40=0 then x:=x*3+25;
      OE(1);
      inc (x);
   end;
   if x>25 then begin dec (x);
                if x=25 then CE(1); end;
   if x=0 then begin CE(0); inc(x); end;
   Port[$20]:=$20;
end;
{$F-}
{$F+}
procedure ProgByte16; interrupt;
begin
   if (x<25) and (x>0) then begin
      PGM(1);
      OE(0);
      for d:=0 to 255 do;
      if Port[adr+1] and $40=0 then begin x:=x*3+25; end;
      OE(1);
      PGM(0);
      inc (x);
   end;
   if x>25 then begin dec (x);
                if x=25 then begin PGM(1); CE(1); end; end;
   if x=0 then begin CE(0); PGM(0); inc(x); end;
   Port[$20]:=$20;
end;
{$F-}
procedure SetFreq(Freq: integer);
var counter: word;
begin
 if Freq=0 then Counter:=0 else counter:= (1190000 div Freq);
 CLI;Port[$40]:= Lo(Counter);Port[$40]:= Hi(Counter);STI;
end;
procedure ExitTimer;   begin SetFreq(0); CLI;
                       SetIntVec($8,@OldTImer); STI; end;
procedure InitTimer; begin CLI; GetIntVec($8,@OldTimer);
                     if tip32k then SetIntVec($8,Addr(ProgByte32))
                               else SetIntVec($8,Addr(ProgByte16));
                     STI; SetFreq(2000); end;
function FileExists(FileName: string): Boolean;
var f: file;
begin
  {$I-}
  Assign(f, FileName);Reset(f);Close(f);
  {$I+}
  FileExists := (IOResult = 0) and (FileName <> '');
end;

Procedure ParamChk;
begin
 if (ParamCount = 2) and ((ParamStr(2)='27256') or (ParamStr(2)='27128') or
 (ParamStr(2)='2764')) then begin end
 else begin WriteLn('');
            WriteLn('EPRREAD datoteka.bin tip');
            WriteLn('EPRREAD                  ->Ime sistemskega programa');
            WriteLn('        datoteka.bin     ->Ime binarne datoteke');
            WriteLn('                     tip ->Tip eproma ');
            WriteLn(''^G); halt (0); end;
 if not FileExists (ParamStr(1)) then begin
    writeln('');
    writeln ('Datoteka ',ParamStr(1),' ne obstaja!'^G);
    halt(0);
    end;
 if ParamStr(2)='27256' then tip32k:=true else tip32k:=false
end;

{ #### GLAVNI PROGRAM #### }

begin
  writeln('');
  write('(c) AX d.o.o. Julij.1994  Eprom Programator  Ver 1.1 ');
  DefPort; ParamChk;
  Writeln('');
  assign(f,ParamStr(1));
  reset(f,1);
  flen:=FileSize(f) ;
  BlockRead(f,blok,flen,err);
  if (flen<>err) then begin
  writeln('Napaka pri branju diska/diskete'^G);halt(0);end;
  close(f);
  CKR(1); CLK; VPG(0); CE(1); OE(1); PGM(1);
  if tip32k then SETadr32(0) else SETadr16(0);
  writeln('Vstavi EPROM ',ParamStr(2),' v programator in pritisni [space]');
  repeat until KeyPressed;
  Writeln('Programiranje...');
  CKR(0); VPG(1); delay(1000);
  x:=25; InitTimer;
  for i:=0 to flen-1 do begin
      Port[adr]:=Blok[i]; Strobe573;
      if tip32k then SETadr32(i div $1000) else SETadr16(i div $1000);
      proc:=Trunc(((i+1)/flen)*100); write(i:5,proc:4,'%',
      chr(8)+chr(8)+chr(8)+chr(8)+chr(8)+chr(8)+chr(8)+chr(8)+chr(8)+chr(8));
      x:=0;
      repeat until x=25;
      OE(0);CE(0);
      for d:=0 to 255 do;
      if Port[adr+1] and $40<>0 then begin
         Writeln(''); WriteLn(' Napaka med programiranjem '^G);
         ExitTimer; CE(1); OE(1); CKR(1); VPG(0); Halt(0); end;
      CE(1); OE(1);
  clk;
  end;
  ExitTimer;
  CE(1); OE(1); VPG(0); CKR(1);
  Writeln('');Writeln('Programiranje uspeno konano');
  delay(1000);
  Writeln('');
  If ParamStr(2)='27256' then begin
     CE(0); OE(0);
     Writeln('Verifikacija...');
     CKR(1); CKR(0);
     for i:=0 to flen-1 do begin
             SETadr32(i div $1000); Load165; d:=0;
             write(i:5,chr(8)+chr(8)+chr(8)+chr(8)+chr(8));
             for ii:=0 to 7 do begin
             d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165; end;
             d:=d xor $ff;
             if Blok[i]<>d then begin CE(1); OE(1); CKR(1);
                WriteLn('');Writeln('Napaka med verifikacijo'^G); halt(0); end;
             clk;
     end;
     CE(1); OE(1); CKR(1);
     writeln('Verifikacija uspeno konano.')
  end;
  If (ParamStr(2)='27128') or (ParamStr(2)='2764') then begin
     CE(0); OE(0);
     SETadr16(0);
     Writeln('Verifikacija...');
     CKR(1); CKR(0);
     for i:=0 to flen-1 do begin
             SETadr16(i div $1000); Load165; d:=0;
             write(i:5,chr(8)+chr(8)+chr(8)+chr(8)+chr(8));
             for ii:=0 to 7 do begin
             d:=(d+d)+((port[adr+1] and $80) shr (7)); Shift165; end;
             d:=d xor $ff;
             if Blok[i]<>d then begin CE(1); OE(1); CKR(1);
                WriteLn('');Writeln('Napaka med verifikacijo'^G); halt(0); end;
             clk;
     end;
     CE(1); OE(1); CKR(1);
     writeln('Verifikacija uspeno konano.')
  end;
writeln('Vzami EPROM iz programatorja.');
end.

